Index: XIOS/trunk/src/date/allleap.cpp
===================================================================
--- XIOS/trunk/src/date/allleap.cpp	(revision 550)
+++ XIOS/trunk/src/date/allleap.cpp	(revision 591)
@@ -46,4 +46,4 @@
 
       ///--------------------------------------------------------------
-} // namespace xmlioserver
+} // namespace xios
 
Index: XIOS/trunk/src/date/allleap.hpp
===================================================================
--- XIOS/trunk/src/date/allleap.hpp	(revision 550)
+++ XIOS/trunk/src/date/allleap.hpp	(revision 591)
@@ -1,7 +1,7 @@
-#ifndef __XMLIO_CAllLeapCalendar__
-#define __XMLIO_CAllLeapCalendar__
+#ifndef __XIOS_CAllLeapCalendar__
+#define __XIOS_CAllLeapCalendar__
 
-/// xios headers ///
-#include "xmlioserver_spl.hpp"
+/// XIOS headers ///
+#include "xios_spl.hpp"
 #include "calendar.hpp"
 
@@ -35,5 +35,5 @@
       }; // class CAllLeapCalendar
 
-} // namespace xmlioserver
+} // namespace xios
 
-#endif // __XMLIO_CAllLeapCalendar__
+#endif // __XIOS_CAllLeapCalendar__
Index: XIOS/trunk/src/date/calendar_type.hpp
===================================================================
--- XIOS/trunk/src/date/calendar_type.hpp	(revision 550)
+++ XIOS/trunk/src/date/calendar_type.hpp	(revision 591)
@@ -1,4 +1,4 @@
-#ifndef __XMLIO_calendar_type__
-#define __XMLIO_calendar_type__
+#ifndef __XIOS_calendar_type__
+#define __XIOS_calendar_type__
 
 #include "allleap.hpp"
@@ -9,3 +9,3 @@
 #include "user_defined.hpp"
 
-#endif //__XMLIO_calendar_type__
+#endif //__XIOS_calendar_type__
Index: XIOS/trunk/src/date/d360.cpp
===================================================================
--- XIOS/trunk/src/date/d360.cpp	(revision 550)
+++ XIOS/trunk/src/date/d360.cpp	(revision 591)
@@ -43,4 +43,4 @@
 
       ///--------------------------------------------------------------
-} // namespace xmlioserver
+} // namespace xios
 
Index: XIOS/trunk/src/date/d360.hpp
===================================================================
--- XIOS/trunk/src/date/d360.hpp	(revision 550)
+++ XIOS/trunk/src/date/d360.hpp	(revision 591)
@@ -1,7 +1,7 @@
-#ifndef __XMLIO_CD360Calendar__
-#define __XMLIO_CD360Calendar__
+#ifndef __XIOS_CD360Calendar__
+#define __XIOS_CD360Calendar__
 
-/// xios headers ///
-#include "xmlioserver_spl.hpp"
+/// XIOS headers ///
+#include "xios_spl.hpp"
 #include "calendar.hpp"
 
@@ -35,6 +35,6 @@
       }; // class CD360Calendar
 
-} // namespace xmlioserver
+} // namespace xios
 
-#endif // __XMLIO_CD360Calendar__
+#endif // __XIOS_CD360Calendar__
 
Index: XIOS/trunk/src/date/gregorian.cpp
===================================================================
--- XIOS/trunk/src/date/gregorian.cpp	(revision 550)
+++ XIOS/trunk/src/date/gregorian.cpp	(revision 591)
@@ -61,4 +61,4 @@
 
       ///--------------------------------------------------------------
-} // namespace xmlioserver
+} // namespace xios
 
Index: XIOS/trunk/src/date/gregorian.hpp
===================================================================
--- XIOS/trunk/src/date/gregorian.hpp	(revision 550)
+++ XIOS/trunk/src/date/gregorian.hpp	(revision 591)
@@ -1,7 +1,7 @@
-#ifndef __XMLIO_CGregorianCalendar__
-#define __XMLIO_CGregorianCalendar__
+#ifndef __XIOS_CGregorianCalendar__
+#define __XIOS_CGregorianCalendar__
 
-/// xios headers ///
-#include "xmlioserver_spl.hpp"
+/// XIOS headers ///
+#include "xios_spl.hpp"
 #include "calendar.hpp"
 
@@ -37,5 +37,5 @@
       }; // class CGregorianCalendar
 
-} // namespace xmlioserver
+} // namespace xios
 
-#endif // __XMLIO_CGregorianCalendar__
+#endif // __XIOS_CGregorianCalendar__
Index: XIOS/trunk/src/date/julian.cpp
===================================================================
--- XIOS/trunk/src/date/julian.cpp	(revision 550)
+++ XIOS/trunk/src/date/julian.cpp	(revision 591)
@@ -55,3 +55,3 @@
 
       ///--------------------------------------------------------------
-} // namespace xmlioserver
+} // namespace xios
Index: XIOS/trunk/src/date/julian.hpp
===================================================================
--- XIOS/trunk/src/date/julian.hpp	(revision 550)
+++ XIOS/trunk/src/date/julian.hpp	(revision 591)
@@ -1,7 +1,7 @@
-#ifndef __XMLIO_CJulianCalendar__
-#define __XMLIO_CJulianCalendar__
+#ifndef __XIOS_CJulianCalendar__
+#define __XIOS_CJulianCalendar__
 
-/// xios headers ///
-#include "xmlioserver_spl.hpp"
+/// XIOS headers ///
+#include "xios_spl.hpp"
 #include "calendar.hpp"
 
@@ -37,5 +37,5 @@
       }; // class CJulianCalendar
 
-} // namespace xmlioserver
+} // namespace xios
 
-#endif // __XMLIO_CJulianCalendar__
+#endif // __XIOS_CJulianCalendar__
Index: XIOS/trunk/src/date/noleap.cpp
===================================================================
--- XIOS/trunk/src/date/noleap.cpp	(revision 550)
+++ XIOS/trunk/src/date/noleap.cpp	(revision 591)
@@ -39,4 +39,4 @@
 
       ///--------------------------------------------------------------
-} // namespace xmlioserver
+} // namespace xios
 
Index: XIOS/trunk/src/date/noleap.hpp
===================================================================
--- XIOS/trunk/src/date/noleap.hpp	(revision 550)
+++ XIOS/trunk/src/date/noleap.hpp	(revision 591)
@@ -1,7 +1,7 @@
-#ifndef __XMLIO_CNoLeapCalendar__
-#define __XMLIO_CNoLeapCalendar__
+#ifndef __XIOS_CNoLeapCalendar__
+#define __XIOS_CNoLeapCalendar__
 
-/// xmlioserver headers ///
-#include "xmlioserver_spl.hpp"
+/// XIOS headers ///
+#include "xios_spl.hpp"
 #include "calendar.hpp"
 
@@ -33,6 +33,6 @@
       }; // class CNoLeapCalendar
 
-} // namespace xmlioserver
+} // namespace xios
 
-#endif // __XMLIO_CNoLeapCalendar__
+#endif // __XIOS_CNoLeapCalendar__
 
Index: XIOS/trunk/src/date/user_defined.cpp
===================================================================
--- XIOS/trunk/src/date/user_defined.cpp	(revision 550)
+++ XIOS/trunk/src/date/user_defined.cpp	(revision 591)
@@ -265,4 +265,4 @@
     return isValid;
   }
-} // namespace xmlioserver
-
+} // namespace xios
+
Index: XIOS/trunk/src/date/user_defined.hpp
===================================================================
--- XIOS/trunk/src/date/user_defined.hpp	(revision 550)
+++ XIOS/trunk/src/date/user_defined.hpp	(revision 591)
@@ -1,7 +1,7 @@
-#ifndef __XMLIO_CUserDefinedCalendar__
-#define __XMLIO_CUserDefinedCalendar__
+#ifndef __XIOS_CUserDefinedCalendar__
+#define __XIOS_CUserDefinedCalendar__
 
-/// xios headers ///
-#include "xmlioserver_spl.hpp"
+/// XIOS headers ///
+#include "xios_spl.hpp"
 #include "calendar.hpp"
 #include "array_new.hpp"
@@ -69,5 +69,5 @@
   }; // class CUserDefinedCalendar
 
-} // namespace xmlioserver
+} // namespace xios
 
-#endif // __XMLIO_CUserDefinedCalendar__
+#endif // __XIOS_CUserDefinedCalendar__